bcm53xx: add basic support for Netgear R7900
[openwrt/openwrt.git] / target / linux / bcm53xx / base-files / lib / upgrade / platform.sh
1 PART_NAME=firmware
2
3 # $(1): file to read magic from
4 # $(2): offset in bytes
5 get_magic_long_at() {
6 dd if="$1" skip=$2 bs=1 count=4 2>/dev/null | hexdump -v -e '1/1 "%02x"'
7 }
8
9 platform_machine() {
10 cat /proc/device-tree/compatible | tr '\0' '\t' | cut -f 1
11 }
12
13 platform_flash_type() {
14 # On NAND devices "rootfs" is UBI volume, so won't be find in /proc/mtd
15 grep -q "\"rootfs\"" /proc/mtd && {
16 echo "serial"
17 return
18 }
19
20 echo "nand"
21 }
22
23 platform_expected_image() {
24 local machine=$(platform_machine)
25
26 case "$machine" in
27 "dlink,dir-885l") echo "seama wrgac42_dlink.2015_dir885l"; return;;
28 "netgear,r6250v1") echo "chk U12H245T00_NETGEAR"; return;;
29 "netgear,r6300v2") echo "chk U12H240T00_NETGEAR"; return;;
30 "netgear,r7000") echo "chk U12H270T00_NETGEAR"; return;;
31 "netgear,r7900") echo "chk U12H315T30_NETGEAR"; return;;
32 "netgear,r8000") echo "chk U12H315T00_NETGEAR"; return;;
33 "netgear,r8500") echo "chk U12H334T00_NETGEAR"; return;;
34 esac
35 }
36
37 platform_identify() {
38 local magic
39
40 magic=$(get_magic_long "$1")
41 case "$magic" in
42 "48445230")
43 echo "trx"
44 return
45 ;;
46 "2a23245e")
47 echo "chk"
48 return
49 ;;
50 "5ea3a417")
51 echo "seama"
52 return
53 ;;
54 esac
55
56 magic=$(get_magic_long_at "$1" 14)
57 [ "$magic" = "55324e44" ] && {
58 echo "cybertan"
59 return
60 }
61
62 echo "unknown"
63 }
64
65 platform_check_image() {
66 [ "$#" -gt 1 ] && return 1
67
68 local file_type=$(platform_identify "$1")
69 local magic
70 local error=0
71
72 case "$file_type" in
73 "chk")
74 local header_len=$((0x$(get_magic_long_at "$1" 4)))
75 local board_id_len=$(($header_len - 40))
76 local board_id=$(dd if="$1" skip=40 bs=1 count=$board_id_len 2>/dev/null | hexdump -v -e '1/1 "%c"')
77 local dev_board_id=$(platform_expected_image)
78 echo "Found CHK image with device board_id $board_id"
79
80 [ -n "$dev_board_id" -a "chk $board_id" != "$dev_board_id" ] && {
81 echo "Firmware board_id doesn't match device board_id ($dev_board_id)"
82 error=1
83 }
84
85 if ! otrx check "$1" -o "$header_len"; then
86 echo "No valid TRX firmware in the CHK image"
87 error=1
88 fi
89 ;;
90 "cybertan")
91 local pattern=$(dd if="$1" bs=1 count=4 2>/dev/null | hexdump -v -e '1/1 "%c"')
92 local dev_pattern=$(platform_expected_image)
93 echo "Found CyberTAN image with device pattern: $pattern"
94
95 [ -n "$dev_pattern" -a "cybertan $pattern" != "$dev_pattern" ] && {
96 echo "Firmware pattern doesn't match device pattern ($dev_pattern)"
97 error=1
98 }
99
100 if ! otrx check "$1" -o 32; then
101 echo "No valid TRX firmware in the CyberTAN image"
102 error=1
103 fi
104 ;;
105 "seama")
106 local img_signature=$(oseama info "$1" | grep "Meta entry:.*signature=" | sed "s/.*=//")
107 local dev_signature=$(platform_expected_image)
108 echo "Found Seama image with device signature: $img_signature"
109
110 [ -n "$dev_signature" -a "seama $img_signature" != "$dev_signature" ] && {
111 echo "Firmware signature doesn't match device signature ($dev_signature)"
112 error=1
113 }
114
115 $(oseama info "$1" -e 0 | grep -q "Meta entry:.*type=firmware") || {
116 echo "Seama container doesn't have firmware entity"
117 error=1
118 }
119 ;;
120 "trx")
121 if ! otrx check "$1"; then
122 echo "Invalid (corrupted?) TRX firmware"
123 error=1
124 fi
125 ;;
126 *)
127 echo "Invalid image type. Please use only .trx files"
128 error=1
129 ;;
130 esac
131
132 return $error
133 }
134
135 platform_pre_upgrade() {
136 export RAMFS_COPY_BIN="${RAMFS_COPY_BIN} /usr/bin/oseama /bin/sed"
137
138 local file_type=$(platform_identify "$1")
139 local dir="/tmp/sysupgrade-bcm53xx"
140 local trx="$1"
141 local offset
142
143 [ "$(platform_flash_type)" != "nand" ] && return
144
145 # Find trx offset
146 case "$file_type" in
147 "chk") offset=$((0x$(get_magic_long_at "$1" 4)));;
148 "cybertan") offset=32;;
149 "seama") return;;
150 esac
151
152 # Extract partitions from trx
153 rm -fR $dir
154 mkdir -p $dir
155 otrx extract "$trx" \
156 ${offset:+-o $offset} \
157 -1 $dir/kernel \
158 -2 $dir/root
159 [ $? -ne 0 ] && {
160 echo "Failed to extract TRX partitions."
161 return
162 }
163
164 # Firmwares without UBI image should be flashed "normally"
165 local root_type=$(identify $dir/root)
166 [ "$root_type" != "ubi" ] && {
167 echo "Provided firmware doesn't use UBI for rootfs."
168 return
169 }
170
171 # Prepare TRX file with just a kernel that will replace current one
172 local linux_length=$(grep "\"linux\"" /proc/mtd | sed "s/mtd[0-9]*:[ \t]*\([^ \t]*\).*/\1/")
173 [ -z "$linux_length" ] && {
174 echo "Unable to find \"linux\" partition size"
175 exit 1
176 }
177 linux_length=$((0x$linux_length))
178 local kernel_length=$(wc -c $dir/kernel | cut -d ' ' -f 1)
179 [ $kernel_length -gt $linux_length ] && {
180 echo "New kernel doesn't fit \"linux\" partition."
181 return
182 }
183 rm -f /tmp/null.bin
184 rm -f /tmp/kernel.trx
185 touch /tmp/null.bin
186 otrx create /tmp/kernel.trx \
187 -f $dir/kernel -b $(($linux_length + 28)) \
188 -f /tmp/null.bin
189 [ $? -ne 0 ] && {
190 echo "Failed to create simple TRX with new kernel."
191 return
192 }
193
194 # Prepare UBI image (drop unwanted extra blocks)
195 local ubi_length=0
196 while [ "$(dd if=$dir/root skip=$ubi_length bs=1 count=4 2>/dev/null)" = "UBI#" ]; do
197 ubi_length=$(($ubi_length + 131072))
198 done
199 dd if=$dir/root of=/tmp/root.ubi bs=131072 count=$((ubi_length / 131072)) 2>/dev/null
200 [ $? -ne 0 ] && {
201 echo "Failed to prepare new UBI image."
202 return
203 }
204
205 # Flash
206 mtd write /tmp/kernel.trx firmware
207 nand_do_upgrade /tmp/root.ubi
208 }
209
210 platform_trx_from_chk_cmd() {
211 local header_len=$((0x$(get_magic_long_at "$1" 4)))
212
213 echo -n dd bs=$header_len skip=1
214 }
215
216 platform_trx_from_cybertan_cmd() {
217 echo -n dd bs=32 skip=1
218 }
219
220 platform_img_from_seama() {
221 local dir="/tmp/sysupgrade-bcm53xx"
222 local offset=$(oseama info "$1" -e 0 | grep "Entity offset:" | sed "s/.*:\s*//")
223 local size=$(oseama info "$1" -e 0 | grep "Entity size:" | sed "s/.*:\s*//")
224
225 # Busybox doesn't support required iflag-s
226 # echo -n dd iflag=skip_bytes,count_bytes skip=$offset count=$size
227
228 rm -fR $dir
229 mkdir -p $dir
230 dd if="$1" of=$dir/image-noheader.bin bs=$offset skip=1
231 dd if=$dir/image-noheader.bin of=$dir/image-entity.bin bs=$size count=1
232
233 echo -n $dir/image-entity.bin
234 }
235
236 platform_do_upgrade() {
237 local file_type=$(platform_identify "$1")
238 local trx="$1"
239 local cmd=
240
241 [ "$(platform_flash_type)" == "nand" ] && {
242 echo "Writing whole image to NAND flash. All erase counters will be lost."
243 }
244
245 case "$file_type" in
246 "chk") cmd=$(platform_trx_from_chk_cmd "$trx");;
247 "cybertan") cmd=$(platform_trx_from_cybertan_cmd "$trx");;
248 "seama") trx=$(platform_img_from_seama "$trx");;
249 esac
250
251 default_do_upgrade "$trx" "$cmd"
252 }